/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using MPLAB® Code Configurator

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.10.3
        Device            :  PIC16F1619
        Driver Version    :  2.00
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X 2.26
 */

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
 */

#include "mcc_generated_files/mcc.h"
#include <string.h>

void Format_to_3Digital(unsigned long Value, unsigned char * String);
void UART_PutRAMString(unsigned char * String);

volatile unsigned char UARTString1[ 0x20 ];
volatile unsigned char UARTString2[ 0x20 ];
volatile unsigned char Timer1Flag = 0;
volatile unsigned char ADDone = 0;
volatile unsigned int TemperatureADValue = 0;
volatile unsigned int TemperaturemV = 0;
volatile unsigned int Temperature100x = 0;
volatile unsigned char SMTDone = 0;
volatile unsigned long FANRPMSMTValue = 0;
volatile unsigned long FANRPM = 0;
volatile unsigned char SMTOverflow = 0;

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    ADCON0bits.CHS = channel_MCP9700;

    while (1)
    {
        static unsigned char DisplayFlag = 0;

        if (Timer1Flag)
        {
            unsigned long Temporary = 0;
            Timer1Flag = 0;

            switch (DisplayFlag)
            {
            case 0:
                Temporary = TemperatureADValue;
                TemperaturemV = ((long) Temporary * 3300) / 1024;
                Temperature100x = (((long) TemperaturemV - 500) * 100) / 10;

                Format_to_3Digital((unsigned long) Temperature100x, (unsigned char *) UARTString1);
                sprintf((char *)UARTString2, "$$$$%s\r\n", (char *) UARTString1);
                UART_PutRAMString((unsigned char *) UARTString2);
                sprintf((char *)UARTString2, "####Temperature :  : %s'C\r\n", (char *)UARTString1);
                UART_PutRAMString((unsigned char *) UARTString2);

                DisplayFlag = 1;
                break;

            case 1:
                if (SMTOverflow)
                {
                    // SMT Overflow
                    FANRPM = 9999999;
                }
                else
                {
                    // Temporary(uS) = FANRPMSMTValue / 1 Peroid Per uS
                    Temporary = FANRPMSMTValue / 1;
                    // 2 Peroid per circle
                    Temporary *= 2;

                    // Fan RPM = ( 1 / Temporary(uS) ) * 60
                    //         = 1K / ( Temporary(uS) * 1K ) * 60
                    //         = 60K / ( Temporary(uS) / 1000 )
                    FANRPM = 60000 / (Temporary / 1000);
                }

                Format_to_3Digital(FANRPM / 10, (unsigned char *) UARTString1);
                sprintf((char *)UARTString2, "$$$$%s\r\n", (char *)UARTString1);
                UART_PutRAMString((unsigned char *) UARTString2);
                sprintf((char *)UARTString2, "####FAN RPM : %sK\r\n", (char *)UARTString1);
                UART_PutRAMString((unsigned char *) UARTString2);

                DisplayFlag = 0;
                break;
            }
        }
    }
}

void Format_to_3Digital(unsigned long Value, unsigned char * String)
{
    if (Value < 1000)
        sprintf((char *) String, "%1d.%02d", (unsigned int) (Value / 100), (unsigned int) (Value % 100));
    else if (Value < 10000)
        sprintf((char *) String, "%2d.%01d", (unsigned int) (Value / 100), (unsigned int) ((Value % 100) / 10));
    else if (Value < 100000)
        sprintf((char *) String, "%3d.", (unsigned int) (Value / 100));
    else
        sprintf((char *) String, "EEE.");
}

void UART_PutRAMString(unsigned char * String)
{
    while (*String != 0x00)
        putch(*String++);
}
/**
End of File
 */