/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB® Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB® Code Configurator - v2.25
        Device            :  PIC16F1619
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 v1.34
        MPLAB             :  MPLAB X v2.35 or v3.00
*/

/*
Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

Microchip licenses to you the right to use, modify, copy and distribute
Software only when embedded on a Microchip microcontroller or digital signal
controller that is integrated into your product or third party product
(pursuant to the sublicense terms in the accompanying license agreement).

You should refer to the license agreement accompanying this Software for
additional information regarding your rights and obligations.

SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
(INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set channel_MCP9700 aliases
#define channel_MCP9700_TRIS               TRISA2
#define channel_MCP9700_LAT                LATA2
#define channel_MCP9700_PORT               RA2
#define channel_MCP9700_ANS                ANSA2
#define channel_MCP9700_SetHigh()    do { LATA2 = 1; } while(0)
#define channel_MCP9700_SetLow()   do { LATA2 = 0; } while(0)
#define channel_MCP9700_Toggle()   do { LATA2 = ~LATA2; } while(0)
#define channel_MCP9700_GetValue()         RA2
#define channel_MCP9700_SetDigitalInput()    do { TRISA2 = 1; } while(0)
#define channel_MCP9700_SetDigitalOutput()   do { TRISA2 = 0; } while(0)

#define channel_MCP9700_SetAnalogMode()   do { ANSA2 = 1; } while(0)
#define channel_MCP9700_SetDigitalMode()   do { ANSA2 = 0; } while(0)
// get/set SMT1SIG aliases
#define SMT1SIG_TRIS               TRISA4
#define SMT1SIG_LAT                LATA4
#define SMT1SIG_PORT               RA4
#define SMT1SIG_ANS                ANSA4
#define SMT1SIG_SetHigh()    do { LATA4 = 1; } while(0)
#define SMT1SIG_SetLow()   do { LATA4 = 0; } while(0)
#define SMT1SIG_Toggle()   do { LATA4 = ~LATA4; } while(0)
#define SMT1SIG_GetValue()         RA4
#define SMT1SIG_SetDigitalInput()    do { TRISA4 = 1; } while(0)
#define SMT1SIG_SetDigitalOutput()   do { TRISA4 = 0; } while(0)

#define SMT1SIG_SetAnalogMode()   do { ANSA4 = 1; } while(0)
#define SMT1SIG_SetDigitalMode()   do { ANSA4 = 0; } while(0)
// get/set RB5 procedures
#define RB5_SetHigh()    do { LATB5 = 1; } while(0)
#define RB5_SetLow()   do { LATB5 = 0; } while(0)
#define RB5_Toggle()   do { LATB5 = ~LATB5; } while(0)
#define RB5_GetValue()         RB5
#define RB5_SetDigitalInput()    do { TRISB5 = 1; } while(0)
#define RB5_SetDigitalOutput()   do { TRISB5 = 0; } while(0)
#define RB5_SetAnalogMode()   do { ANSB5 = 1; } while(0)
#define RB5_SetDigitalMode()   do { ANSB5 = 0; } while(0)
// get/set RB7 procedures
#define RB7_SetHigh()    do { LATB7 = 1; } while(0)
#define RB7_SetLow()   do { LATB7 = 0; } while(0)
#define RB7_Toggle()   do { LATB7 = ~LATB7; } while(0)
#define RB7_GetValue()         RB7
#define RB7_SetDigitalInput()    do { TRISB7 = 1; } while(0)
#define RB7_SetDigitalOutput()   do { TRISB7 = 0; } while(0)
#define RB7_SetPullup()    do { WPUB7 = 1; } while(0)
#define RB7_ResetPullup()   do { WPUB7 = 0; } while(0)
// get/set PWM3OUT aliases
#define PWM3OUT_TRIS               TRISC1
#define PWM3OUT_LAT                LATC1
#define PWM3OUT_PORT               RC1
#define PWM3OUT_ANS                ANSC1
#define PWM3OUT_SetHigh()    do { LATC1 = 1; } while(0)
#define PWM3OUT_SetLow()   do { LATC1 = 0; } while(0)
#define PWM3OUT_Toggle()   do { LATC1 = ~LATC1; } while(0)
#define PWM3OUT_GetValue()         RC1
#define PWM3OUT_SetDigitalInput()    do { TRISC1 = 1; } while(0)
#define PWM3OUT_SetDigitalOutput()   do { TRISC1 = 0; } while(0)

#define PWM3OUT_SetAnalogMode()   do { ANSC1 = 1; } while(0)
#define PWM3OUT_SetDigitalMode()   do { ANSC1 = 0; } while(0)
// get/set PWM4OUT aliases
#define PWM4OUT_TRIS               TRISC2
#define PWM4OUT_LAT                LATC2
#define PWM4OUT_PORT               RC2
#define PWM4OUT_ANS                ANSC2
#define PWM4OUT_SetHigh()    do { LATC2 = 1; } while(0)
#define PWM4OUT_SetLow()   do { LATC2 = 0; } while(0)
#define PWM4OUT_Toggle()   do { LATC2 = ~LATC2; } while(0)
#define PWM4OUT_GetValue()         RC2
#define PWM4OUT_SetDigitalInput()    do { TRISC2 = 1; } while(0)
#define PWM4OUT_SetDigitalOutput()   do { TRISC2 = 0; } while(0)

#define PWM4OUT_SetAnalogMode()   do { ANSC2 = 1; } while(0)
#define PWM4OUT_SetDigitalMode()   do { ANSC2 = 0; } while(0)
// get/set D6 aliases
#define D6_TRIS               TRISC3
#define D6_LAT                LATC3
#define D6_PORT               RC3
#define D6_ANS                ANSC3
#define D6_SetHigh()    do { LATC3 = 1; } while(0)
#define D6_SetLow()   do { LATC3 = 0; } while(0)
#define D6_Toggle()   do { LATC3 = ~LATC3; } while(0)
#define D6_GetValue()         RC3
#define D6_SetDigitalInput()    do { TRISC3 = 1; } while(0)
#define D6_SetDigitalOutput()   do { TRISC3 = 0; } while(0)

#define D6_SetAnalogMode()   do { ANSC3 = 1; } while(0)
#define D6_SetDigitalMode()   do { ANSC3 = 0; } while(0)
// get/set D5 aliases
#define D5_TRIS               TRISC4
#define D5_LAT                LATC4
#define D5_PORT               RC4
#define D5_WPU                WPUC4
#define D5_SetHigh()    do { LATC4 = 1; } while(0)
#define D5_SetLow()   do { LATC4 = 0; } while(0)
#define D5_Toggle()   do { LATC4 = ~LATC4; } while(0)
#define D5_GetValue()         RC4
#define D5_SetDigitalInput()    do { TRISC4 = 1; } while(0)
#define D5_SetDigitalOutput()   do { TRISC4 = 0; } while(0)

#define D5_SetPullup()    do { WPUC4 = 1; } while(0)
#define D5_ResetPullup()   do { WPUC4 = 0; } while(0)
// get/set D4 aliases
#define D4_TRIS               TRISC5
#define D4_LAT                LATC5
#define D4_PORT               RC5
#define D4_WPU                WPUC5
#define D4_SetHigh()    do { LATC5 = 1; } while(0)
#define D4_SetLow()   do { LATC5 = 0; } while(0)
#define D4_Toggle()   do { LATC5 = ~LATC5; } while(0)
#define D4_GetValue()         RC5
#define D4_SetDigitalInput()    do { TRISC5 = 1; } while(0)
#define D4_SetDigitalOutput()   do { TRISC5 = 0; } while(0)

#define D4_SetPullup()    do { WPUC5 = 1; } while(0)
#define D4_ResetPullup()   do { WPUC5 = 0; } while(0)
// get/set D7 aliases
#define D7_TRIS               TRISC7
#define D7_LAT                LATC7
#define D7_PORT               RC7
#define D7_ANS                ANSC7
#define D7_SetHigh()    do { LATC7 = 1; } while(0)
#define D7_SetLow()   do { LATC7 = 0; } while(0)
#define D7_Toggle()   do { LATC7 = ~LATC7; } while(0)
#define D7_GetValue()         RC7
#define D7_SetDigitalInput()    do { TRISC7 = 1; } while(0)
#define D7_SetDigitalOutput()   do { TRISC7 = 0; } while(0)

#define D7_SetAnalogMode()   do { ANSC7 = 1; } while(0)
#define D7_SetDigitalMode()   do { ANSC7 = 0; } while(0)

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    GPIO and peripheral I/O initialization
 * @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);

#endif // PIN_MANAGER_H
/**
 End of File
*/